.386
.MODEL FLAT,STDCALL
option casemap:none

   include  \masm32\include\windows.inc
   include  \masm32\include\user32.inc
   include  \masm32\include\kernel32.inc
   include  \masm32\include\gdi32.inc
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\gdi32.lib

WinMain      PROTO :DWORD, :DWORD, :DWORD, :SDWORD

.data

  ClassName   DB "SimpleWinClass",0
    AppName   DB "Maurer Rose",0
     scaleX    DD ?
     scaleY      DD ?
   cxClient   DD ?
   cyClient   DD ?
         x1   DD  ?
         y1   DD  ?
         x2   DD  ?
         y2   DD  ?
      tempx     DD  ?
      tempy   DD  ?
      mypie   real4   0.0174603174603174603174603174603174603
      theta     real4   0.0
       incr   real4   1.0
     radius   real4   1.0;6.0
     half			real4		0.5;
       move     real4   3.0

.data?

hInstance HINSTANCE ?
CommandLine LPSTR   ?

LOWORD  MACRO  bigword
   mov  eax,bigword
   and  eax,0FFFFh
ENDM

HIWORD  MACRO bigword
    mov   ebx,bigword
    shr   ebx,16
ENDM

RGB MACRO red, green, blue

   mov   al,blue
   shl   eax,8
   add   al,green
   shl   eax,8
   add   al,red
   and   eax,0FFFFFFh

ENDM
;----------------------------------------------------------------------------
.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
	
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD
	LOCAL   wc:WNDCLASSEX
	LOCAL   msg:MSG
	LOCAL   hwnd:HWND
	
	mov wc.cbSize,SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, OFFSET WndProc
	mov wc.cbClsExtra, NULL
	mov wc.cbWndExtra, NULL
	mov eax, hInstance
	mov wc.hInstance, eax
	mov wc.hbrBackground, COLOR_WINDOW+1
	mov wc.lpszMenuName, NULL
	mov wc.lpszClassName, OFFSET ClassName
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, NULL
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax
	
	invoke RegisterClassEx, addr wc
	
	invoke  CreateWindowEx, NULL, addr ClassName, addr AppName, \
        WS_OVERLAPPEDWINDOW, 200, 200, 500, 500, NULL, NULL ,\
        hInst, NULL
	mov hwnd, eax
	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
@@:
	invoke GetMessage, addr msg, NULL, 0, 0
	cmp eax, 0
	jz @F
	invoke TranslateMessage, addr msg
	invoke DispatchMessage, addr msg
	jmp @B
@@:
	
	mov eax, msg.wParam
	ret
	
WinMain endp

WndProc proc hWnd:dword, uMsg:dword, wParam:dword, lParam:dword
	
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rc:RECT
	
	mov eax,uMsg
	
.IF eax==WM_SIZE
	
	LOWORD  lParam
	mov  cxClient,eax                   
	
	HIWORD  lParam
	mov  cyClient,ebx
	
	invoke GetClientRect, hWnd, addr rc
	mov eax, rc.right
	mov tempx, eax
	mov eax, rc.bottom
	mov tempy, eax
	
	mov eax, 0
	ret
	
.ELSEIF  eax==WM_PAINT

	invoke  BeginPaint,hWnd, ADDR ps
	mov  hdc,eax
	
	finit
	fild  tempx
	fstp  scaleX
	
	fild  tempy
	fstp  scaleY
	
	push esi
	mov   esi,0
	
	.repeat
	
		fld theta
		fmul mypie
		fcos
		fmul half
		fadd half
		fmul scaleX
		fistp x1
		
		fld theta
		fmul mypie
		fsin 
		fmul half
		fadd half
		fmul scaleY
		fistp y1
		
		fld theta
		fmul mypie
		fmul move
		fcos
		fmul half
		fadd half
		fmul scaleX
		fistp x2
		
		
		fld theta
		fmul mypie
		fmul move
		fsin
		fmul half
		fadd half
		fmul scaleY
		fistp y2
		
		fld theta
		fadd incr
		fstp theta
		
		invoke MoveToEx, hdc, x1, y1, NULL
		invoke LineTo, hdc, x2,y2
		
		add esi, 1
		
	.until esi==360
	pop esi
	
	invoke  EndPaint,hWnd, ADDR ps
	
.ELSEIF eax==WM_DESTROY
	
	invoke  PostQuitMessage,NULL
	
.ELSE
	
	invoke DefWindowProc, hWnd, uMsg, wParam, lParam
	ret
	
.ENDIF

xor    eax,eax
ret

WndProc endp

end start
